require "omniauth-oauth2"

module OmniAuth
  module Strategies
    class Lightspeed < OmniAuth::Strategies::OAuth2
      option :name, :lightspeed
      option :client_options, site: "https://api.merchantos.com/API",
                              authorize_url: "https://cloud.merchantos.com/oauth/authorize.php",
                              token_url: "https://cloud.merchantos.com/oauth/access_token.php"

      def request_phase
        options[:scope] ||= "employee:all"
        super
      end

      protected

      def build_access_token
        verifier = request.params["code"]
        callback_url_without_params = callback_url.split("?")[0]
        client.auth_code.get_token(verifier, {:redirect_uri => callback_url_without_params}.merge(token_params.to_hash(:symbolize_keys => true)), deep_symbolize(options.auth_token_params))
      end
    end
  end
end
